Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Protected Attributes
Lucene::LockFactory Class Referenceabstract

Base class for Locking implementation. Directory uses instances of this class to implement locking. Note that there are some useful tools to verify that your LockFactory is working correctly: {}, LockStressTest}, { LockVerifyServer}. More...

`#include <LockFactory.h>`

Inheritance diagram for Lucene::LockFactory:

## Public Member Functions

virtual | ~LockFactory ()
virtual String | getClassName ()
boost::shared_ptr< LockFactory > | shared_from_this ()
virtual void | setLockPrefix (const String &lockPrefix)
| Set the prefix in use for all locks created in this LockFactory. This is normally called once, when a Directory gets this LockFactory instance. However, you can also call this (after this instance is assigned to a Directory) to override the prefix in use. This is helpful if you're running Lucene on machines that have different mount points for the same shared directory. More...
virtual String | getLockPrefix ()
| Get the prefix in use for all locks created in this LockFactory. More...
virtual LockPtr | makeLock (const String &lockName)=0
| Return a new Lock instance identified by lockName. More...
virtual void | clearLock (const String &lockName)=0
| Attempt to clear (forcefully unlock and remove) the specified lock. Only call this at a time when you are certain this lock is no longer in use. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()

## Protected Attributes

String | lockPrefix
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Detailed Description

Base class for Locking implementation. Directory uses instances of this class to implement locking. Note that there are some useful tools to verify that your LockFactory is working correctly: {}, LockStressTest}, { LockVerifyServer}.

See also
  LockVerifyServer
  LockStressTest
  VerifyingLockFactory

## Constructor & Destructor Documentation

## ◆ ~LockFactory()

virtual Lucene::LockFactory::~LockFactory | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::LockFactory::_getClassName | ( |  | ) |

inline static

## ◆ clearLock()

virtual void Lucene::LockFactory::clearLock | ( | const String & | lockName | ) |

pure virtual

Attempt to clear (forcefully unlock and remove) the specified lock. Only call this at a time when you are certain this lock is no longer in use.

Parameters

  lockName | name of the lock to be cleared.

Implemented in Lucene::SingleInstanceLockFactory, Lucene::SimpleFSLockFactory, Lucene::NativeFSLockFactory, and Lucene::NoLockFactory.

## ◆ getClassName()

virtual String Lucene::LockFactory::getClassName | ( |  | ) |

inline virtual

Reimplemented in Lucene::SimpleFSLockFactory, Lucene::SingleInstanceLockFactory, Lucene::NativeFSLockFactory, Lucene::FSLockFactory, and Lucene::NoLockFactory.

## ◆ getLockPrefix()

virtual String Lucene::LockFactory::getLockPrefix | ( |  | ) |

virtual

Get the prefix in use for all locks created in this LockFactory.

## ◆ makeLock()

virtual LockPtr Lucene::LockFactory::makeLock | ( | const String & | lockName | ) |

pure virtual

Return a new Lock instance identified by lockName.

Parameters

  lockName | name of the lock to be created.

Implemented in Lucene::SimpleFSLockFactory, Lucene::SingleInstanceLockFactory, Lucene::NoLockFactory, and Lucene::NativeFSLockFactory.

## ◆ setLockPrefix()

virtual void Lucene::LockFactory::setLockPrefix | ( | const String & | lockPrefix | ) |

virtual

Set the prefix in use for all locks created in this LockFactory. This is normally called once, when a Directory gets this LockFactory instance. However, you can also call this (after this instance is assigned to a Directory) to override the prefix in use. This is helpful if you're running Lucene on machines that have different mount points for the same shared directory.

## ◆ shared_from_this()

boost::shared_ptr< LockFactory > Lucene::LockFactory::shared_from_this | ( |  | ) |

inline

## Field Documentation

## ◆ lockPrefix

String Lucene::LockFactory::lockPrefix

protected

The documentation for this class was generated from the following file:

- LockFactory.h

clucene.sourceforge.net